# Reserved Keys

kSCResvLink =                               "__LINK__"                        # CFString
kSCResvInactive =                           "__INACTIVE__"                   

kSCPropInterfaceName =                      "InterfaceName"                   # CFString
kSCPropMACAddress =                         "MACAddress"                      # CFString
kSCPropUserDefinedName =                    "UserDefinedName"                 # CFString
kSCPropVersion =                            "Version"                         # CFString

# Preference Keys
kSCPrefCurrentSet =                         "CurrentSet"                      # CFString
kSCPrefNetworkServices =                    "NetworkServices"                 # CFDictionary
kSCPrefSets =                               "Sets"                            # CFDictionary
kSCPrefSystem =                             "System"                          # CFDictionary

# Component Keys
kSCCompNetwork =                            "Network"                        
kSCCompService =                            "Service"                        
kSCCompGlobal =                             "Global"                         
kSCCompHostNames =                          "HostNames"                      
kSCCompInterface =                          "Interface"                      
kSCCompSystem =                             "System"                         
kSCCompUsers =                              "Users"                          

# Regex key which matches any component
kSCCompAnyRegex =                           "[^/]+"                          

# Network Entity Keys
kSCEntNetAirPort =                          "AirPort"                         # CFDictionary
kSCEntNetAppleTalk =                        "AppleTalk"                       # CFDictionary
kSCEntNetDHCP =                             "DHCP"                            # CFDictionary
kSCEntNetDNS =                              "DNS"                             # CFDictionary
kSCEntNetEthernet =                         "Ethernet"                        # CFDictionary
kSCEntNetInterface =                        "Interface"                       # CFDictionary
kSCEntNetIPv4 =                             "IPv4"                            # CFDictionary
kSCEntNetIPv6 =                             "IPv6"                            # CFDictionary
kSCEntNetLink =                             "Link"                            # CFDictionary
kSCEntNetModem =                            "Modem"                           # CFDictionary
kSCEntNetNetInfo =                          "NetInfo"                         # CFDictionary
# kSCEntNetNIS =                           "???" */                          /* RESERVED FOR FUTURE USE
kSCEntNetPPP =                              "PPP"                             # CFDictionary
kSCEntNetPPPoE =                            "PPPoE"                           # CFDictionary
kSCEntNetProxies =                          "Proxies"                         # CFDictionary

# kSCCompNetwork Properties
kSCPropNetOverridePrimary =                 "OverridePrimary"                 # CFNumber (0 or 1)
kSCPropNetServiceOrder =                    "ServiceOrder"                    # CFArray[CFString]
kSCPropNetPPPOverridePrimary =              "PPPOverridePrimary"              # CFNumber (0 or 1)

# kSCCompNetworkInterface Properties
kSCPropNetInterfaces =                      "Interfaces"                      # CFArray[CFString]

# kSCCompNetworkHostNames Properties
kSCPropNetLocalHostName =                   "LocalHostName"                   # CFString

# kSCEntNetAirPort (Hardware) Entity Keys
kSCPropNetAirPortAllowNetCreation =         "AllowNetCreation"                # CFNumber (0 or 1)
kSCPropNetAirPortAuthPassword =             "AuthPassword"                    # CFData
kSCPropNetAirPortAuthPasswordEncryption =   "AuthPasswordEncryption"          # CFString
kSCPropNetAirPortJoinMode =                 "JoinMode"                        # CFString
kSCPropNetAirPortPowerEnabled =             "PowerEnabled"                    # CFNumber (0 or 1)
kSCPropNetAirPortPreferredNetwork =         "PreferredNetwork"                # CFString
kSCPropNetAirPortSavePasswords =            "SavePasswords"                   # CFNumber (0 or 1)

# kSCPropNetAirPortJoinMode values
kSCValNetAirPortJoinModePreferred =         "Preferred"                      
kSCValNetAirPortJoinModeRecent =            "Recent"                         
kSCValNetAirPortJoinModeStrongest =         "Strongest"                      

# kSCEntNetAppleTalk Entity Keys
kSCPropNetAppleTalkComputerName =           "ComputerName"                    # CFString
kSCPropNetAppleTalkComputerNameEncoding =   "ComputerNameEncoding"            # CFNumber
kSCPropNetAppleTalkConfigMethod =           "ConfigMethod"                    # CFString
kSCPropNetAppleTalkDefaultZone =            "DefaultZone"                     # CFString
kSCPropNetAppleTalkNetworkID =              "NetworkID"                       # CFNumber
kSCPropNetAppleTalkNetworkRange =           "NetworkRange"                    # CFArray[CFNumber]
kSCPropNetAppleTalkNodeID =                 "NodeID"                          # CFNumber
kSCPropNetAppleTalkSeedNetworkRange =       "SeedNetworkRange"                # CFArray[CFNumber]
kSCPropNetAppleTalkSeedZones =              "SeedZones"                       # CFArray[CFString]

# kSCPropNetAppleTalkConfigMethod values
kSCValNetAppleTalkConfigMethodNode =        "Node"                           
kSCValNetAppleTalkConfigMethodRouter =      "Router"                         
kSCValNetAppleTalkConfigMethodSeedRouter =  "SeedRouter"                     

# kSCEntNetDNS Entity Keys
kSCPropNetDNSDomainName =                   "DomainName"                      # CFString
kSCPropNetDNSSearchDomains =                "SearchDomains"                   # CFArray[CFString]
kSCPropNetDNSServerAddresses =              "ServerAddresses"                 # CFArray[CFString]
kSCPropNetDNSSortList =                     "SortList"                        # CFArray[CFString]

# kSCEntNetEthernet (Hardware) Entity Keys

# kSCEntNetInterface Entity Keys
kSCPropNetInterfaceDeviceName =             "DeviceName"                      # CFString
kSCPropNetInterfaceHardware =               "Hardware"                        # CFString
kSCPropNetInterfaceType =                   "Type"                            # CFString
kSCPropNetInterfaceSubType =                "SubType"                         # CFString
kSCPropNetInterfaceSupportsModemOnHold =    "SupportsModemOnHold"             # CFNumber (0 or 1)

# kSCPropNetInterfaceType values
kSCValNetInterfaceTypeEthernet =            "Ethernet"                       
kSCValNetInterfaceTypePPP =                 "PPP"                            

# kSCPropNetServiceSubType values (for PPP)
kSCValNetInterfaceSubTypePPPoE =            "PPPoE"                          
kSCValNetInterfaceSubTypePPPSerial =        "PPPSerial"                      
kSCValNetInterfaceSubTypePPTP =             "PPTP"                           

# kSCEntNetIPv4 Entity Keys
kSCPropNetIPv4Addresses =                   "Addresses"                       # CFArray[CFString]
kSCPropNetIPv4ConfigMethod =                "ConfigMethod"                    # CFString
kSCPropNetIPv4DHCPClientID =                "DHCPClientID"                    # CFString
kSCPropNetIPv4Router =                      "Router"                          # CFString
kSCPropNetIPv4SubnetMasks =                 "SubnetMasks"                     # CFArray[CFString]
kSCPropNetIPv4DestAddresses =               "DestAddresses"                   # CFArray[CFString]
kSCPropNetIPv4BroadcastAddresses =          "BroadcastAddresses"              # CFArray[CFString]

# kSCPropNetIPv4ConfigMethod values
kSCValNetIPv4ConfigMethodBOOTP =            "BOOTP"                          
kSCValNetIPv4ConfigMethodDHCP =             "DHCP"                           
kSCValNetIPv4ConfigMethodINFORM =           "INFORM"                         
kSCValNetIPv4ConfigMethodLinkLocal =        "LinkLocal"                      
kSCValNetIPv4ConfigMethodManual =           "Manual"                         
kSCValNetIPv4ConfigMethodPPP =              "PPP"                            

# kSCEntNetIPv6 Entity Keys
kSCPropNetIPv6Addresses =                   "Addresses"                       # CFArray[CFString]
kSCPropNetIPv6ConfigMethod =                "ConfigMethod"                    # CFString

# kSCEntNetLink Entity Keys
kSCPropNetLinkActive =                      "Active"                          # CFBoolean
kSCPropNetLinkDetaching =                   "Detaching"                       # CFBoolean

# kSCEntNetModem (Hardware) Entity Keys
kSCPropNetModemConnectionScript =           "ConnectionScript"                # CFString
kSCPropNetModemConnectSpeed =               "ConnectSpeed"                    # CFNumber
kSCPropNetModemDataCompression =            "DataCompression"                 # CFNumber (0 or 1)
kSCPropNetModemDialMode =                   "DialMode"                        # CFString
kSCPropNetModemErrorCorrection =            "ErrorCorrection"                 # CFNumber (0 or 1)
kSCPropNetModemHoldCallWaitingAudibleAlert =  "HoldCallWaitingAudibleAlert"     # CFNumber (0 or 1)
kSCPropNetModemHoldDisconnectOnAnswer =     "HoldDisconnectOnAnswer"          # CFNumber (0 or 1)
kSCPropNetModemHoldEnabled =                "HoldEnabled"                     # CFNumber (0 or 1)
kSCPropNetModemHoldReminder =               "HoldReminder"                    # CFNumber (0 or 1)
kSCPropNetModemHoldReminderTime =           "HoldReminderTime"                # CFNumber
kSCPropNetModemNote =                       "Note"                            # CFString
kSCPropNetModemPulseDial =                  "PulseDial"                       # CFNumber (0 or 1)
kSCPropNetModemSpeaker =                    "Speaker"                         # CFNumber (0 or 1)
kSCPropNetModemSpeed =                      "Speed"                           # CFNumber

# kSCPropNetModemDialMode values
kSCValNetModemDialModeIgnoreDialTone =      "IgnoreDialTone"                 
kSCValNetModemDialModeManual =              "Manual"                         
kSCValNetModemDialModeWaitForDialTone =     "WaitForDialTone"                

# kSCEntNetNetInfo Entity Keys
kSCPropNetNetInfoBindingMethods =           "BindingMethods"                  # CFString
kSCPropNetNetInfoServerAddresses =          "ServerAddresses"                 # CFArray[CFString]
kSCPropNetNetInfoServerTags =               "ServerTags"                      # CFArray[CFString]
kSCPropNetNetInfoBroadcastServerTag =       "BroadcastServerTag"              # CFString

# kSCPropNetNetInfoBindingMethods values
kSCValNetNetInfoBindingMethodsBroadcast =   "Broadcast"                      
kSCValNetNetInfoBindingMethodsDHCP =        "DHCP"                           
kSCValNetNetInfoBindingMethodsManual =      "Manual"                         

# kSCPropNetNetInfoBroadcastServerTag default value
kSCValNetNetInfoDefaultServerTag =          "network"                        

# kSCEntNetNIS Entity Keys
# RESERVED FOR FUTURE USE

# kSCEntNetPPP Entity Keys
kSCPropNetPPPConnectTime =                  "ConnectTime"                     # CFNumber
kSCPropNetPPPDeviceLastCause =              "DeviceLastCause"                 # CFNumber
kSCPropNetPPPDialOnDemand =                 "DialOnDemand"                    # CFNumber (0 or 1)
kSCPropNetPPPDisconnectOnIdle =             "DisconnectOnIdle"                # CFNumber (0 or 1)
kSCPropNetPPPDisconnectOnIdleTimer =        "DisconnectOnIdleTimer"           # CFNumber
kSCPropNetPPPDisconnectOnLogout =           "DisconnectOnLogout"              # CFNumber (0 or 1)
kSCPropNetPPPDisconnectOnSleep =            "DisconnectOnSleep"               # CFNumber (0 or 1)
kSCPropNetPPPIdleReminderTimer =            "IdleReminderTimer"               # CFNumber
kSCPropNetPPPIdleReminder =                 "IdleReminder"                    # CFNumber (0 or 1)
kSCPropNetPPPLastCause =                    "LastCause"                       # CFNumber
kSCPropNetPPPLogfile =                      "Logfile"                         # CFString
kSCPropNetPPPPlugins =                      "Plugins"                         # CFArray[CFString]
kSCPropNetPPPSessionTimer =                 "SessionTimer"                    # CFNumber
kSCPropNetPPPStatus =                       "Status"                          # CFString
kSCPropNetPPPUseSessionTimer =              "UseSessionTimer"                 # CFNumber (0 or 1)
kSCPropNetPPPVerboseLogging =               "VerboseLogging"                  # CFNumber (0 or 1)

# Auth:
kSCPropNetPPPAuthName =                     "AuthName"                        # CFString
kSCPropNetPPPAuthPassword =                 "AuthPassword"                    # CFString
kSCPropNetPPPAuthPasswordEncryption =       "AuthPasswordEncryption"          # CFString
kSCPropNetPPPAuthProtocol =                 "AuthProtocol"                    # CFArray[CFString]

# kSCPropNetPPPAuthProtocol values
kSCValNetPPPAuthProtocolCHAP =              "CHAP"                            # CFString
kSCValNetPPPAuthProtocolPAP =               "PAP"                             # CFString

# Comm:
kSCPropNetPPPCommAlternateRemoteAddress =   "CommAlternateRemoteAddress"      # CFString
kSCPropNetPPPCommConnectDelay =             "CommConnectDelay"                # CFNumber
kSCPropNetPPPCommDisplayTerminalWindow =    "CommDisplayTerminalWindow"       # CFNumber (0 or 1)
kSCPropNetPPPCommRedialCount =              "CommRedialCount"                 # CFNumber
kSCPropNetPPPCommRedialEnabled =            "CommRedialEnabled"               # CFNumber (0 or 1)
kSCPropNetPPPCommRedialInterval =           "CommRedialInterval"              # CFNumber
kSCPropNetPPPCommRemoteAddress =            "CommRemoteAddress"               # CFString
kSCPropNetPPPCommTerminalScript =           "CommTerminalScript"              # CFString
kSCPropNetPPPCommUseTerminalScript =        "CommUseTerminalScript"           # CFNumber (0 or 1)

# CCP:
kSCPropNetPPPCCPEnabled =                   "CCPEnabled"                      # CFNumber (0 or 1)

# IPCP:
kSCPropNetPPPIPCPCompressionVJ =            "IPCPCompressionVJ"               # CFNumber (0 or 1)

# LCP:
kSCPropNetPPPLCPEchoEnabled =               "LCPEchoEnabled"                  # CFNumber (0 or 1)
kSCPropNetPPPLCPEchoFailure =               "LCPEchoFailure"                  # CFNumber
kSCPropNetPPPLCPEchoInterval =              "LCPEchoInterval"                 # CFNumber
kSCPropNetPPPLCPCompressionACField =        "LCPCompressionACField"           # CFNumber (0 or 1)
kSCPropNetPPPLCPCompressionPField =         "LCPCompressionPField"            # CFNumber (0 or 1)
kSCPropNetPPPLCPMRU =                       "LCPMRU"                          # CFNumber
kSCPropNetPPPLCPMTU =                       "LCPMTU"                          # CFNumber
kSCPropNetPPPLCPReceiveACCM =               "LCPReceiveACCM"                  # CFNumber
kSCPropNetPPPLCPTransmitACCM =              "LCPTransmitACCM"                 # CFNumber

# kSCEntNetPPPoE Entity Keys
# RESERVED FOR FUTURE USE

# kSCEntNetPPPSerial Entity Keys
# RESERVED FOR FUTURE USE

# kSCEntNetProxies Entity Keys
kSCPropNetProxiesExceptionsList =           "ExceptionsList"                  # CFArray[CFString]
kSCPropNetProxiesFTPEnable =                "FTPEnable"                       # CFNumber (0 or 1)
kSCPropNetProxiesFTPPassive =               "FTPPassive"                      # CFNumber (0 or 1)
kSCPropNetProxiesFTPPort =                  "FTPPort"                         # CFNumber
kSCPropNetProxiesFTPProxy =                 "FTPProxy"                        # CFString
kSCPropNetProxiesGopherEnable =             "GopherEnable"                    # CFNumber (0 or 1)
kSCPropNetProxiesGopherPort =               "GopherPort"                      # CFNumber
kSCPropNetProxiesGopherProxy =              "GopherProxy"                     # CFString
kSCPropNetProxiesHTTPEnable =               "HTTPEnable"                      # CFNumber (0 or 1)
kSCPropNetProxiesHTTPPort =                 "HTTPPort"                        # CFNumber
kSCPropNetProxiesHTTPProxy =                "HTTPProxy"                       # CFString
kSCPropNetProxiesHTTPSEnable =              "HTTPSEnable"                     # CFNumber (0 or 1)
kSCPropNetProxiesHTTPSPort =                "HTTPSPort"                       # CFNumber
kSCPropNetProxiesHTTPSProxy =               "HTTPSProxy"                      # CFString
kSCPropNetProxiesRTSPEnable =               "RTSPEnable"                      # CFNumber (0 or 1)
kSCPropNetProxiesRTSPPort =                 "RTSPPort"                        # CFNumber
kSCPropNetProxiesRTSPProxy =                "RTSPProxy"                       # CFString
kSCPropNetProxiesSOCKSEnable =              "SOCKSEnable"                     # CFNumber (0 or 1)
kSCPropNetProxiesSOCKSPort =                "SOCKSPort"                       # CFNumber
kSCPropNetProxiesSOCKSProxy =               "SOCKSProxy"                      # CFString

# kSCCompUsers Entity Keys
kSCEntUsersConsoleUser =                    "ConsoleUser"                    

# kSCPropUsersConsoleUser Properties
kSCPropUsersConsoleUserName =               "Name"                            # CFString
kSCPropUsersConsoleUserUID =                "UID"                             # CFString
kSCPropUsersConsoleUserGID =                "GID"                             # CFString

# kSCCompSystem Properties
kSCPropSystemComputerName =                 "ComputerName"                    # CFString
kSCPropSystemComputerNameEncoding =         "ComputerNameEncoding"            # CFNumber

# Configuration Store Definitions
# domain prefixes
kSCDynamicStoreDomainFile =                 "File:"                          
kSCDynamicStoreDomainPlugin =               "Plugin:"                        
kSCDynamicStoreDomainSetup =                "Setup:"                         
kSCDynamicStoreDomainState =                "State:"                         
kSCDynamicStoreDomainPrefs =                "Prefs:"                         

# kSCDynamicStoreDomainSetup Properties
kSCDynamicStorePropSetupCurrentSet =        "CurrentSet"                      # CFString
kSCDynamicStorePropSetupLastUpdated =       "LastUpdated"                    

# Properties
kSCDynamicStorePropNetInterfaces =          "Interfaces"                      # CFArray[CFString]
kSCDynamicStorePropNetPrimaryInterface =    "PrimaryInterface"                # CFString
kSCDynamicStorePropNetPrimaryService =      "PrimaryService"                  # CFString
kSCDynamicStorePropNetServiceIDs =          "ServiceIDs"                      # CFArray[CFString]
